// JavaScript Document

const cArr=["Oops"];

var rArr = ["Amazing","Brilliant","Excellent","Good","GoodJob","Superb","Welldone","Wonderful"];
var wArr = [];
var nArr = ["ThinkAgain","LetsTryAgain","LetsGiveAnotherShot","TryOnceAgain"];

var audio;
var func;

function getElement(str){
	return (document.getElementById(str));
}

function createTag(str){
	return (document.createElement(str));
}

function disableSubmitBTN(){
	submitBtn.style.pointerEvents = "none";
	submitBtn.style.opacity = 0.5;
}

function enableSubmitBTN(){
	getElement("submitBtn").style.pointerEvents = "auto";
	getElement("submitBtn").style.opacity = 1;
}

function disableReset(){
	getElement("resetBtn").style.pointerEvents = "none";
	getElement("resetBtn").style.opacity = 0.5;
}

function enableReset(){
	getElement("resetBtn").style.pointerEvents = "auto";
	getElement("resetBtn").style.opacity = 1;
}

function disableObj(Obj){
	Obj.style.pointerEvents = "none";
	//Obj.style.opacity = 0.5;
}

function enableObj(Obj){
	Obj.style.pointerEvents = "auto";
	//answerBtn.style.opacity = 1;
}


function appendAtGlobal(par,kid)
{
	//var top,left;
	
	//appendAtBody(kid);
	var cx,cy,px,py,ox,oy;
	cx = parseInt(kid.style.left);
	cy = parseInt(kid.style.top);
	
	px = parseInt(par.style.left);
	py = parseInt(par.style.top);
	
	
	
	ox = px - cx;
	oy = py - cy;
	
//	console.log("X:  ", ox, cx, px);
//	console.log("Y:  ", oy, cy, py);
	
	par.appendChild(kid);
	kid.style.left ="0px";
	kid.style.top = "0px";

	kid.style.left = (parseInt(kid.style.left) - ox) + "px";
	kid.style.top = (parseInt(kid.style.top) - oy) + "px";
	
	
}


function appendAt(id, obj)
{
	var cx,cy,px,py,ox,oy;
	var tar = getElement(id);
	kid = obj;
	var pa = kid.parentNode;
	var offset;
	cx = 0;
	cy = 0;
	
	var count=0;
	
	while(pa != tar)
	{

		offset = $(kid).offset();
		cx += offset.left;
		cy += offset.top;
		kid = pa;
		pa = kid.parentNode;
		
		count++;
		
		//console.log("HERE2222:  ",kid, kid.style.left, kid.style.top);
	}
	
	tar.appendChild(obj);
	obj.style.left = "0px";
	obj.style.top = "0px";
	obj.style.left = cx + "px";
	obj.style.top = cy + "px";
	
	//console.log("PAR: ",tar, "    obj:  ", obj);
	//console.log("FINALLY:  ", cx,cy);
	
	//wait(5000);
}


function wait(ms){
   var start = new Date().getTime();
   var end = start;
   while(end < start + ms) {
     end = new Date().getTime();
  }
}

//================================================================================================================================================
function finishActivity()
{
	console.log("FINISHING..............");

	setTimeout(makeAnimationSpace, makeAnimationSpaceDelay);
}

function playWrongFeedback(id, fun)
{
	func = fun;
		sourceOGG.src = "../__audio/Right"+id+".ogg";
	sourceMP3.src = "../__audio/Right"+id+".mp3";
	audio.addEventListener("ended", onAudioEnded);
	//console.log("AAAAAAAAAAAAAAAA:  ", audio);
	audio.load();
audio.play();
}


function playRemainingWrongFeedback(id, fun)
{
	func = fun;
		sourceOGG.src = "../__audio/MoreGo"+id+".ogg";
	sourceMP3.src = "../__audio/MoreGo"+id+".mp3";
	audio.addEventListener("ended", onAudioEnded);
	//console.log("AAAAAAAAAAAAAAAA:  ", audio);
	audio.load();
audio.play();
	
}


function onAudioEnded(e)
{
	//console.log("AUDIO END===========");
	audio.removeEventListener("ended", onAudioEnded);
	try{
		func();
		}catch(err)
		{}
	
}


function playFeedback(val, fun){
	
	var ranNum;
	func = fun;
	//console.log("GGGGGG:  ", val, func);
	switch(val){
		case "right":
			ranNum = parseInt(Math.random()*(rArr.length));
			//console.log(ranNum)
		sourceOGG.src = "../__audio/" + rArr[ranNum] + ".ogg";
		sourceMP3.src = "../__audio/" + rArr[ranNum] + ".mp3";
		break;
		case "wrong":
			wArr = cArr;
			if(attempts == 1)
			{
				wArr = wArr.concat(nArr);
			}
			//console.log("AAAAAA:  ", attempts);
			if(attempts == ATTEMPTS_ALLOWED)
			{
				for(var ii=0;ii<nArr.length;ii++)
				{
					if(wArr.indexOf(nArr[ii]) > -1)
					{
						wArr.splice(wArr.indexOf(nArr[ii]),1);
					}
				}				
			}		
			//console.log("*******:  ", wArr);	
			ranNum = parseInt(Math.random()*(wArr.length));			
						sourceOGG.src = "../__audio/" + wArr[ranNum] + ".ogg";
			sourceMP3.src = "../__audio/" + wArr[ranNum] + ".mp3";
		break
		case "correct":
						sourceOGG.src = "../__audio/ThisIsTheCorrectAns.ogg";
			sourceMP3.src = "../__audio/ThisIsTheCorrectAns.mp3"
		break
		case "completed":
						sourceOGG.src = "../__audio/completed.ogg";
			sourceMP3.src = "../__audio/completed.mp3";
		break
	}
	audio.addEventListener("ended", onAudioEnded);
	audio.load();
audio.play();
}



function playAnimation(){
	if(fCount == 20)
	{
		playFeedback("actComp");
	}
	if(fCount < 72){
		fCount++;
		animDiv.src ="Assets/activityComplete/actComp_"+fCount+".png";
		
	}else{
		clearInterval(interval);
	}
}

function makeAnimationSpace(){
	document.getElementById("main").style.display = "none";
	var actComDiv = document.createElement("div");
	document.body.appendChild(actComDiv);
	actComDiv.style.position = "absolute";
	actComDiv.style.left = 0+"px";
	actComDiv.style.top = 0+"px";
	actComDiv.style.width = 0+"px";
	actComDiv.style.height = 720+"px";
	actComDiv.style.zIndex = "200";
	actComDiv.style.backgroundColor = "#fff";
	
	animDiv = document.createElement("div");
	actComDiv.appendChild(animDiv);
	animDiv.style.position = "absolute";
	animDiv.style.width = 1280+"px";
	animDiv.style.height = 233+"px";
	animDiv.style.top = 243+"px";
	animDiv.style.overflow = "hidden";
	animDiv.style.backgroundImage = "url(../__images/activityComplete.png)";
	animDiv.style.backgroundSize = "1280px 233px";
	animDiv.style.backgroundRepeat = "no-repeat";	
	$(actComDiv).animate({width:1280},500);	
	setTimeout(completedDelay, 500);
}

function completedDelay(){
	var activityText = document.createElement("img");
	animDiv.appendChild(activityText);
	activityText.src = "../__images/activity.png";
	activityText.setAttribute("id","activityText");	
	var completedText = document.createElement("img");
	animDiv.appendChild(completedText);
	completedText.src = "../__images/completed.png";	
	completedText.setAttribute("id","completedText");		
	playFeedback("completed");
}


